/* jshint esversion: 6 */

const _ = require('lodash');
const path = require('path');
const mime = require('mime');

/**
 * @param {{ predicate: (function(String): Boolean), type: String }[]} knownTypes
 * @param {String} filepath
 * @returns {String|undefined}
 */
exports.typeFromPath = function(knownTypes, filepath) {
	const filename = path.basename(filepath);
	const match = _.find(knownTypes, kt => kt.predicate(filename));
	if (match) return match.type;

	const ext = _.trimStart(path.extname(filepath), '.');
	if (ext) {
		return mime.getType(ext);
	} else {
		const name = path.basename(filepath);
		return _.get(typesByName, name);
	}
};
